from os import getenv
import pytest
import shutil

def add_path():
	import os.path
	import sys
	path = os.path.realpath(os.path.abspath(__file__))
	sys.path.insert(0, os.path.dirname(os.path.dirname(path)))

add_path()

from ValVault import (
	init as init_auth, new_user,
	get_users, get_pass,
	get_name, get_aliases,
)
from ValVault.storage import json_write, settingsPath, utilsPath

def clean_up():
	if (not getenv("VALUTILS_PATH")):
		return
	shutil.rmtree(utilsPath)

@pytest.fixture(scope="function", autouse=True)
def init_env(request):
	json_write({"insecure": True}, settingsPath / "config.json")
	init_auth()
	request.addfinalizer(clean_up)

def test_db():
	username = getenv("USERNAME")
	password = getenv("PASSWORD")
	new_user(username, password)
	assert username in get_users(), "Username not in db"
	assert get_pass(username) == password, "Password not in db"

def test_alias():
	from ValVault.auth import db
	username = getenv("USERNAME")
	password = getenv("PASSWORD")
	alias = "alias"
	db.save_user(username, password, alias)
	assert get_name(alias) == username
	assert alias in get_aliases()
